%global api	0.2
%global major	0
%global libname	%mklibname abydos %{api} %{major}
%global loaname	%mklibname abydos-loa %{api} %{major}
%global nilname	%mklibname abydos-nil %{api} %{major}
%global devname	%mklibname abydos %{api} -d

%global pluginname	%mklibname abydos%{api}-plugins

%if "%{?distro_section}" == "tainted"
%global tainted 1
%endif

Name:		abydos
Summary:	An image loading library which relies heavily on cairo
Version:	0.2.11
Release:	%mkrel 1
License:	LGPLv2+
Group:		System/Libraries
Url:		https://snisurset.net/code/abydos/
Source0:	https://snisurset.net/code/abydos/files/abydos-%{version}.tar.xz
Patch1:		abydos-linking.patch
Patch2:		abydos-plugindir.patch
Patch3:		abydos-pil.patch
Patch7:		abydos-fix-32bit-build.patch
Patch9:		abydos-c23.patch
BuildRequires:	meson
BuildRequires:	bison
BuildRequires:	flex
BuildRequires:	freeimage-devel
BuildRequires:	giflib-devel
BuildRequires:	python3-pillow-devel
BuildRequires:	cmake(Qt5Core)
BuildRequires:	cmake(Qt5Gui)
BuildRequires:	pkgconfig(libavif)
BuildRequires:	pkgconfig(libjxl)
BuildRequires:	pkgconfig(libspectre)
BuildRequires:	pkgconfig(libquicktime)
BuildRequires:	pkgconfig(libgxps)
BuildRequires:	pkgconfig(libarchive)
BuildRequires:	pkgconfig(aom)
BuildRequires:	pkgconfig(cairo)
BuildRequires:	pkgconfig(cfitsio)
BuildRequires:	pkgconfig(dav1d)
BuildRequires:	pkgconfig(evas)
BuildRequires:	pkgconfig(gdal)
BuildRequires:	pkgconfig(IL)
BuildRequires:	pkgconfig(gegl-0.4)
BuildRequires:	pkgconfig(MagickCore)
BuildRequires:	pkgconfig(gdlib)
BuildRequires:	pkgconfig(libavcodec)
%if 0%{?tainted:1}
BuildRequires:	pkgconfig(libheif)
%endif
BuildRequires:	pkgconfig(libicns)
BuildRequires:	pkgconfig(libpgf)
#BuildRequires:	pkgconfig(libnsbmp)
#BuildRequires:	pkgconfig(libnsgif)
BuildRequires:	pkgconfig(rlottie)
BuildRequires:	pkgconfig(libpng)
BuildRequires:	pkgconfig(libraw_r)
BuildRequires:	pkgconfig(librevenge-stream-0.0)
BuildRequires:	pkgconfig(librsvg-2.0)
BuildRequires:	pkgconfig(libtiff-4)
BuildRequires:	pkgconfig(libunarr)
BuildRequires:	pkgconfig(libwebpdemux)
BuildRequires:	pkgconfig(libwebpmux)
BuildRequires:	pkgconfig(libwpg-0.3)
BuildRequires:	pkgconfig(poppler-glib)
BuildRequires:	pkgconfig(spng)
BuildRequires:	pkgconfig(ddjvuapi)
BuildRequires:	pkgconfig(libwmf)
BuildRequires:	pkgconfig(imlib2)
BuildRequires:	pkgconfig(OpenImageIO)
BuildRequires:	netpbm-devel

%description
Abydos is an image loading library which relies heavily on cairo.

It handles both raster and vector graphics. It supports animation,
multi page images, multi variant images (different versions of the
image optimized for different sizes) and layers.

%package config
Summary:	Plugin configuration for %{name}
Group:		System/Libraries
BuildArch:	noarch

%description config
This package contains the plugin configuration files for %{name}.

%package -n %{libname}
Summary:	An image loading library which relies heavily on cairo
Group:		System/Libraries
Requires:	%{name}-config >= %{version}-%{release}
Requires:	%{pluginname} = %{version}-%{release}
%if ! %{with syshwy}
Provides:	bundled(highway) = 0.12.2
%endif

%description -n %{libname}
Abydos is an image loading library which relies heavily on cairo.

It handles both raster and vector graphics. It supports animation,
multi page images, multi variant images (different versions of the
image optimized for different sizes) and layers.

%package -n %{loaname}
Summary:        An image loading library which relies heavily on cairo
Group:          System/Libraries

%description -n %{loaname}
Abydos is an image loading library which relies heavily on cairo.

It handles both raster and vector graphics. It supports animation,
multi page images, multi variant images (different versions of the
image optimized for different sizes) and layers.

%package -n %{nilname}
Summary:        An image loading library which relies heavily on cairo
Group:          System/Libraries

%description -n %{nilname}
Abydos is an image loading library which relies heavily on cairo.

It handles both raster and vector graphics. It supports animation,
multi page images, multi variant images (different versions of the
image optimized for different sizes) and layers.

%package -n %{pluginname}
Summary:	Image loading plugins for abydos
Group:		System/Libraries
Conflicts:	%{_lib}abydos0.2_0 < 0.2.6

%description -n %{pluginname}
This package contains image loading plugins for abydos.

%package -n %{devname}
Summary:	Development files and headers for %{name}
Group:		Development/Other
Requires:	%{libname} = %{version}-%{release}
Requires:	%{loaname} = %{version}-%{release}
Requires:	%{nilname} = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}

%description -n %{devname}
This package contains the development files and headers for %{name}.

%prep
%autosetup -p1

# fix meson.build
sed -i -e 's/\(\s\+res\s\+=\s\+\)no/\1NO/g' meson.build

# skip pik plugin on unsupported arches
%ifarch %{arm} %{ix86} aarch64
sed -i -e '/subdir/s/^\(\s\+.*pik\)/#\1/g' plugins/meson.build
%endif

find . -name "*.d" -delete

%build
%global optflags %{optflags} -Wno-incompatible-pointer-types
%ifarch %ix86 %arm32
export CPPFLAGS="-DDMC_HAS_LARGE_FILE_SUPPORT=0"
%endif
%meson \
  -Dwith-libheif=%{?tainted:auto}%{?!tainted:disabled} \
  -Dwith-flif=disabled \
  -Dwith-libansilove=disabled \
  -Dwith-libbpg=disabled \
  -Dwith-libmxf=disabled \
  -Dwith-libnsbmp=disabled \
  -Dwith-libnsgif=disabled \
  -Dwith-librosprite=disabled \
  -Dwith-grok=disabled \
  -Dwith-vips=disabled \
  -Dwith-openslide=disabled \
  -Dwith-resvg=disabled
%meson_build

%install
%meson_install

%files config
%dir %{_sysconfdir}/abydos/
%config(noreplace) %{_sysconfdir}/abydos/alias.conf
%config(noreplace) %{_sysconfdir}/abydos/plugins.conf

%files -n %{libname}
%license COPYING
%{_libdir}/libabydos-%{api}.so.%{major}{,.*}

%files -n %{loaname}
%license COPYING
%{_libdir}/libabydos-loa-%{api}.so.%{major}{,.*}

%files -n %{pluginname}
%license COPYING
%dir %{_libdir}/abydos/
%{_libdir}/abydos/*

%files -n %{nilname}
%license COPYING
%{_libdir}/libabydos-nil-%{api}.so.%{major}{,.*}

%files -n %{devname}
%{_includedir}/abydos/
%{_libdir}/libabydos-%{api}.so
%{_libdir}/libabydos-loa-%{api}.so
%{_libdir}/libabydos-nil-%{api}.so
%{_libdir}/pkgconfig/abydos.pc


%changelog
* Fri Apr 25 2025 wally <wally> 0.2.11-1.mga10
+ Revision: 2178615
- new version 0.2.11
- fix build with GCC15

* Fri Mar 07 2025 papoteur <papoteur> 0.2.10-7.mga10.tainted
+ Revision: 2161407
- rebuild for python 3.13

* Mon Dec 30 2024 daviddavid <daviddavid> 0.2.10-6.mga10.tainted
+ Revision: 2131664
- rebuild for new libraw 0.21.3

* Sun Dec 08 2024 daviddavid <daviddavid> 0.2.10-5.mga10.tainted
+ Revision: 2122900
- rebuild for new ffmpeg 7.1

* Sat Jul 06 2024 daviddavid <daviddavid> 0.2.10-4.mga10.tainted
+ Revision: 2080062
- rebuild for new libjxl 0.10.3

* Thu Jan 18 2024 daviddavid <daviddavid> 0.2.10-3.mga10.tainted
+ Revision: 2031934
- rebuild for new openimageio 2.5.6.0

* Fri Dec 22 2023 tv <tv> 0.2.10-2.mga10.tainted
+ Revision: 2020876
- Rebuild for python-3.12

* Wed Nov 08 2023 daviddavid <daviddavid> 0.2.10-1.mga10.tainted
+ Revision: 2005241
- new version: 0.2.10
- enable libunarr and libpgf support
- enable libjxl support (upstream removed the bundled JPEG-XL in favour of using libjxl)

* Wed Nov 08 2023 daviddavid <daviddavid> 0.2.9-16.mga10
+ Revision: 2005159
- add patch to fix libwebp linking
- rebuild for new libavif 1.0.1

* Sun Jan 01 2023 wally <wally> 0.2.9-15.mga9.tainted
+ Revision: 1928490
- rebuild for openimageio 2.4.6.1

* Mon Dec 12 2022 ns80 <ns80> 0.2.9-14.mga9.tainted
+ Revision: 1920971
- rebuild for new libtiff

* Wed Nov 16 2022 daviddavid <daviddavid> 0.2.9-13.mga9
+ Revision: 1908063
- rebuild for new libavif

* Sat Oct 22 2022 papoteur <papoteur> 0.2.9-12.mga9
+ Revision: 1898515
- rebuild for ghostscript 10.0.0
+ ns80 <ns80>
- rebuild for new major number of libgs

* Sun Sep 04 2022 wally <wally> 0.2.9-10.mga9.tainted
+ Revision: 1883787
- rebuild for libavif 0.10.1

* Thu Aug 25 2022 wally <wally> 0.2.9-9.mga9.tainted
+ Revision: 1880199
- fix aarch64 build with bundled highway

* Thu Aug 25 2022 wally <wally> 0.2.9-8.mga9
+ Revision: 1880179
- build jpegxl support with bundled highway 0.12.2

* Thu Apr 14 2022 umeabot <umeabot> 0.2.9-7.mga9.tainted
+ Revision: 1849645
- Mageia 9 Mass Rebuild

* Tue Mar 29 2022 kekepower <kekepower> 0.2.9-6.mga9
+ Revision: 1831767
- Rebuild for new libavif

* Sat Mar 12 2022 mrambo3501 <mrambo3501> 0.2.9-5.mga9.tainted
+ Revision: 1790647
- rebuild for ffmpeg 5.0

* Mon Feb 14 2022 tv <tv> 0.2.9-4.mga9
+ Revision: 1774626
- Rebuild for python-3.10

* Wed Dec 29 2021 wally <wally> 0.2.9-3.mga9
+ Revision: 1765249
- rebuild for imagemagick 7.0.11.14

* Sat Dec 25 2021 wally <wally> 0.2.9-2.mga9.tainted
+ Revision: 1763694
- rebuild for openexr 3.1.3

* Tue Dec 07 2021 wally <wally> 0.2.9-1.mga9
+ Revision: 1761021
- new version 0.2.9

* Sat Jul 31 2021 wally <wally> 0.2.7-2.mga9.tainted
+ Revision: 1738363
- build pik plugin only on x86_64

* Sat Jul 31 2021 wally <wally> abydos-0.2.7-1.mga9
+ Revision: 1738346
- new version 0.2.7
- switch to meson build
- split out image loaders from lib pkg

* Sat Feb 27 2021 neoclust <neoclust> 0.2.3-5.mga9.tainted
+ Revision: 1692832
- Rebuild against new imagemagick

* Wed Nov 25 2020 kekepower <kekepower> 0.2.3-4.mga8.tainted
+ Revision: 1649139
- Rebuild for new dav1d

* Mon Nov 16 2020 kekepower <kekepower> 0.2.3-3.mga8
+ Revision: 1646563
- Rebuild for new Imagemagick lib major

* Tue Nov 03 2020 akien <akien> 0.2.3-2.mga8
+ Revision: 1641990
- Rebuild for new libraw_r

* Tue Oct 20 2020 tv <tv> 0.2.3-1.mga8
+ Revision: 1637269
- update filelist
- 0.2.3

* Tue Sep 29 2020 tv <tv> 0.2.2-4.mga8.tainted
+ Revision: 1631073
+ rebuild (emptylog)

* Sat Sep 26 2020 tv <tv> 0.2.2-3.mga8.tainted
+ Revision: 1630580
- rebuild for new libraw_r

* Fri Sep 18 2020 wally <wally> 0.2.2-2.mga8
+ Revision: 1628656
- make plugins co-installable with older api versions
- fix plugin linking issues

* Thu Sep 17 2020 wally <wally> 0.2.2-1.mga8
+ Revision: 1628048
- new version 0.2.2

* Tue Feb 18 2020 umeabot <umeabot> 0.1.4-3.mga8.tainted
+ Revision: 1541582
- Mageia 8 Mass Rebuild
+ wally <wally>
- replace deprecated %%configure2_5x

* Mon Dec 30 2019 kekepower <kekepower> 0.1.4-2.mga8.tainted
+ Revision: 1474956
- Rebuild for new imagemagick

* Tue Nov 26 2019 wally <wally> 0.1.4-1.mga8
+ Revision: 1462952
- new version 0.1.4
- enable libraw support

* Tue Apr 16 2019 wally <wally> 0.1.3-2.mga7.tainted
+ Revision: 1391699
- enable netpbm support

* Sun Apr 14 2019 wally <wally> 0.1.3-1.mga7.tainted
+ Revision: 1390109
- imported package abydos

